/*********************************/
/* Test of socket communications */
/*            Client             */
/*********************************/

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <netdb.h>
#include <errno.h>
#include <time.h>
#include <string.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <string.h>
#define PORTNUM 1500


void delay(long int del)
{
struct timespec *req_del;
struct timespec *req_rem;
req_del=(struct timespec*)malloc(sizeof(struct timespec));
req_rem=(struct timespec*)malloc(sizeof(struct timespec));
req_del->tv_sec=0;
req_del->tv_nsec=del*1000000;
req_rem->tv_sec=0;
req_rem->tv_nsec=0;
if(nanosleep(req_del,req_rem)) printf("Error delay\n");
}


main(int argc, char * argv[])
{
  int sockfd;
  int pid;
  int i,j,nbytes;
  struct sockaddr_in serv_addr;
  struct hostent * hp;
  char *buf,*in;
  int  msg_min,msg_max,msg_loop,msg_size,step,err,inc_msg;


    for(i = 2; i < argc; i ++)
      {
                switch(argv[i][0]) {
		 case 'm': msg_min  = atoi(argv[i]+1); break;
	         case 'M': msg_max  = atoi(argv[i]+1); break;
		 case 'l': msg_loop = atoi(argv[i]+1); break;
		 case 'i': inc_msg  = atoi(argv[i]+1); break;
    default: fprintf(stderr,"WARNING: unrecognized option: %s\n",argv[i]);
                         break;                                                           
			           }             
      }

  if ((hp=gethostbyname(argv[1])) == 0)
  {
    printf("Error call gethostbyname\n");
    return -1;
  }

  /* Define server address */
  bzero(&serv_addr, sizeof(serv_addr));
  bcopy(hp->h_addr, &serv_addr.sin_addr, hp->h_length);
  serv_addr.sin_family = hp->h_addrtype;
  serv_addr.sin_port = htons(PORTNUM);


  /* Create socket */
  if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
  {
    printf("Error create socket\n");
    return -1;
  }

//  printf("Client address:%s\n", inet_ntoa(serv_addr.sin_addr));

  if (connect(sockfd, (struct sockaddr*)&serv_addr, sizeof(serv_addr))==-1)
  {
    perror("Error call connect\n");
    return -1;
  }


//   step=(msg_max-msg_min)/100;
    msg_size=msg_min;
    buf=(char *)malloc(msg_max);
    in=(char *)malloc(5);
    for(i=0; i < msg_max; i++)
      buf[i] = 31;
    while(msg_size <= msg_max)
      {
        for(i=0;i<msg_loop;i++) {

        err=send(sockfd, buf, msg_size, 0);
		delay(50);
        if(err!=msg_size)
          printf("Message size: %d loop: %d ->code=%d errno=%d\n",
            msg_size,i,err,errno);
	}
	msg_size += inc_msg;
      }
	free(buf);


  close(sockfd);

  return 0;
}
