/*********************************/
/* Test of socket communications */
/*            Server             */
/*********************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <netdb.h>
#include <unistd.h>
#include <errno.h>
#include <time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/file.h>


struct stat {
unsigned long rx_bytes;
unsigned long rx_packet;
unsigned long rx_errors;
unsigned long rx_drop;
unsigned long rx_fifo;
unsigned long rx_frame;
unsigned long rx_compr;
unsigned long rx_multic;
unsigned long tx_bytes;
unsigned long tx_packet;
unsigned long tx_errors;
unsigned long tx_drop;
unsigned long tx_fifo;
unsigned long collisions;
unsigned long tx_carrier;
unsigned long tx_compr;
};

int statistic(struct stat*);

void delay(long int del)
{
struct timespec *req_del;
struct timespec *req_rem;
req_del=(struct timespec*)malloc(sizeof(struct timespec));
req_rem=(struct timespec*)malloc(sizeof(struct timespec));
req_del->tv_sec=0;
req_del->tv_nsec=del*1000000;
req_rem->tv_sec=0;
req_rem->tv_nsec=0;
if(nanosleep(req_del,req_rem)) printf("Error delay\n");
}


#define PORTNUM 1500

int main(int argc, char* argv[])
{
  struct stat *out_stat;
  int sockfd, ns;
  int pid;
  int nport;
  int i,j,k;
  struct sockaddr_in serv_addr, clnt_addr;
  struct hostent *hp;
  char *buf, *in,hname[80];
  int nbytes;
  int fout;
  int  msg_min,msg_max,msg_loop,msg_size,inc_msg,step;
  long f_rx_err,f_tx_err,f_carrier;
  int addrlen;
  int LostBytes,TransferErrors;

out_stat=malloc(sizeof(struct stat));
setvbuf(stdout,NULL,_IONBF,0);


for(i = 1; i < argc; i ++)
                switch(argv[i][0]) {
		 case 'm': msg_min  = atoi(argv[i]+1); break;
	         case 'M': msg_max  = atoi(argv[i]+1); break;
		 case 'l': msg_loop = atoi(argv[i]+1); break;
		 case 'i': inc_msg  = atoi(argv[i]+1); break;
 default: fprintf(stderr,"WARNING: unrecognized option: %s\n",argv[i]);
                         break;
			           }



  /* Convert port number to network format */
  nport = htons((u_short)PORTNUM);
  /* Create socket for tcp/ip */
  if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
  {
    printf("Error create socket\n");
    exit(1);
  }

  /* Set address of communicate socket (uzel) */
  bzero(&serv_addr, sizeof(serv_addr));
  serv_addr.sin_family = AF_INET;
  serv_addr.sin_addr.s_addr = INADDR_ANY;
   serv_addr.sin_port = nport;
//  hp=gethostbyname("localhost");
//  bcopy(hp->h_addr, &serv_addr.sin_addr.s_addr, hp->h_length);

  if (bind(sockfd, (struct sockaddr *)&serv_addr, sizeof(serv_addr)) == -1)
  {
    perror("Error create bind name\n");
    exit(1);
  }

  printf("Server ready <-> ");
  if (listen(sockfd, 5)==-1)
  {
    printf("Error call listen\n");
    return -1;
  }


    bzero(&clnt_addr, sizeof(clnt_addr));

    if ( (ns=accept(sockfd, (struct sockaddr *)&clnt_addr, &addrlen)) == -1)
    {
      printf("Error call accept\n");
      return -1;
    }


    printf("Client answer. \n");

statistic(out_stat);
f_rx_err=out_stat->rx_errors;
f_tx_err=out_stat->tx_errors;
f_carrier=out_stat->tx_carrier;

printf("----------------------------Ethernet statistic-------------------\n");
printf(" Size    Rx_error   Tx_error  Carrier   LostBytes  TransferErrors\n");



//Start recive

    msg_size=msg_min;
    buf=(char *)malloc(msg_max);
    LostBytes = TransferErrors = 0;

    while(msg_size <= msg_max)
      {
        for(i=0;i<msg_loop;i++)
	{
        for(j=0; j<msg_size ;j++)
          buf[j] = 0;
		delay(50);  
        nbytes = recv(ns, buf, msg_size,/*MSG_WAITALL*/0);
        if(nbytes < msg_size)
          LostBytes += msg_size - nbytes;
        for(j=0; j<nbytes; j++)
	  if(buf[j]!=31)TransferErrors++;
	}

     statistic(out_stat);
printf(" %-12d%-10d%-10d%-10d%-10d%-6d\r",
msg_size,out_stat->rx_errors-f_rx_err,out_stat->tx_errors-f_tx_err,
out_stat->tx_carrier-f_carrier,LostBytes,TransferErrors);
	msg_size += inc_msg;
      }
       free(buf);

    /* Parent process: close socket */
    close(ns);
    printf("\n");

  close(sockfd);
  printf("-----------------------------------------------------------------\n\n");
  if(out_stat->rx_errors-f_rx_err !=0 | out_stat->tx_errors-f_tx_err !=0 | TransferErrors!=0)
    { 
      fprintf(stderr,"----------------------------Ethernet statistic-------------------\n");
      fprintf(stderr," Size    Rx_error   Tx_error  Carrier   LostBytes  TransferErrors\n");
      fprintf(stderr," %-12d%-10d%-10d%-10d%-10d%-6d\r", 
      msg_size,out_stat->rx_errors-f_rx_err,out_stat->tx_errors-f_tx_err,
      out_stat->tx_carrier-f_carrier,LostBytes,TransferErrors);
      fprintf(stderr,"	\n\n\tEthernet Adapter test: Failed\n\n\tPossible cause: Adapter malfunction.\n\n");
      printf("	Ethernet Adapter test: Failed\n\n\tPossible cause: Adapter malfunction.\n\n");exit(1);
      }
  
  

  if(out_stat->tx_carrier-f_carrier!=0 | LostBytes !=0)
     {
      fprintf(stderr,"----------------------------Ethernet statistic-------------------\n");
      fprintf(stderr," Size    Rx_error   Tx_error  Carrier   LostBytes  TransferErrors\n");
      fprintf(stderr," %-12d%-10d%-10d%-10d%-10d%-6d\r", 
      msg_size,out_stat->rx_errors-f_rx_err,out_stat->tx_errors-f_tx_err,
      out_stat->tx_carrier-f_carrier,LostBytes,TransferErrors);
      fprintf(stderr,"	\n\n\tEthernet Adapter test: Failed\n\n\tPossible cause: Adapter error or cable problem.\n\n");
      printf("	Ethernet Adapter test: Failed\n\n\tPossible cause: Adapter error or cable problem.\n\n"); exit(1);
     }
  printf("	Ethernet Adapter test: Passed\n\n");
  exit(0);
}



int statistic(struct stat *loc)
{

   int nbyte=0;
   int fdnet;
   char *str;
   char *inf;
  str=(char *)malloc(1000);
  inf=(char *)malloc(100);
   fdnet=open("/proc/net/dev",O_RDONLY);
//    printf("%d",fdnet);
   while(read(fdnet,str,1))
    {
      if(str[0]=='e')
      while(read(fdnet,str+nbyte,1))
      {
        nbyte++;
       }
            str[nbyte]='\0';
    }
//  loc=(struct stat*)malloc(sizeof(struct stat));
  str=strstr(str,"eth0");
  str=str+5;
//  printf("%s\n",str);
    sscanf(str,"%ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld",&loc->rx_bytes,&loc->rx_packet,
    &loc->rx_errors,&loc->rx_drop,&loc->rx_fifo,&loc->rx_frame,&loc->rx_compr,&loc->rx_multic,
    &loc->tx_bytes,&loc->tx_packet,&loc->tx_errors,&loc->tx_drop,&loc->tx_fifo,&loc->collisions,&loc->tx_carrier,
    &loc->tx_compr);

//  printf(" %s %ld %ld %ld", inf, loc->rx_errors,loc->tx_errors,loc->collisions);

}



